using System;
using System.Collections.Generic;
using System.Reflection;
using System.Data;

namespace NBearMapping
{
    public class CustomObjectMemberSetter : IMemberSetter
    {
        private Type objType;

        internal CustomObjectMemberSetter(Type objType)
        {
            this.objType = objType;
        }

        #region IMemberSetter Members

        public void SetMembers(object targetObj, Dictionary<string, ObjectMember> members)
        {
            Check.Require(targetObj != null, "targetObj could not be null.");
            Check.Require(members != null, "members could not be null.");

            CustomObjectMemberHandlerCache.GetMemberSetter(objType)(targetObj, members);
        }

        #endregion
    }
}
