using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace NBearMapping
{
    public sealed class DataReaderMemberGetter : IMemberGetter
    {
        private DataReaderMemberGetter() { }

        #region IMemberGetter Members

        public List<ObjectMember> GetMembers(object targetObj)
        {
            Check.Require(targetObj != null, "targetObj could not be null.");
            Check.Require(targetObj is IDataReader, "targetObj MUST be a Data Reader");

            IDataReader reader = targetObj as IDataReader;

            List<ObjectMember> members = new List<ObjectMember>();

            for (int i = 0; i < reader.FieldCount; ++i)
            {
                members.Add(new ObjectMember(reader.GetName(i), reader.GetFieldType(i), reader.GetValue(i) == DBNull.Value ? null : reader.GetValue(i)));
            }

            return members;
        }

        #endregion

        private static DataReaderMemberGetter singleton = new DataReaderMemberGetter();

        public static DataReaderMemberGetter Instance
        {
            get { return singleton; }
        }
    }
}
