using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace NBearMapping
{
    public class DataRowMemberGetter : IMemberGetter
    {
        private DataRowMemberGetter() { }

        #region IMemberGetter Members

        public List<ObjectMember> GetMembers(object targetObj)
        {
            Check.Require(targetObj != null, "targetObj could not be null.");
            Check.Require(targetObj is DataRow, "targetObj MUST be a DataRow");

            DataRow row = targetObj as DataRow;

            List<ObjectMember> members = new List<ObjectMember>();

            for (int i = 0; i < row.Table.Columns.Count; ++i)
            {
                members.Add(new ObjectMember(row.Table.Columns[i].ColumnName, row.Table.Columns[i].DataType, row[i] == DBNull.Value ? null : row[i]));
            }

            return members;
        }

        #endregion

        private static DataRowMemberGetter singleton = new DataRowMemberGetter();

        public static DataRowMemberGetter Instance
        {
            get { return singleton; }
        }
    }
}
